%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Check_MPC(MPC)

% MPC (карточка RBAR) | .card | .ID | .Nastran_ID | .GA | .GB | .CNA | .CNB | .CMA | .CMB | .ALPHA |
% MPC (карточка RBE2) | .card | .ID | .Nastran_ID | .GN | .CM | .GM(:,1) | .ALPHA |
% MPC (карточка RBE3) | .card | .ID | .Nastran_ID | .REFGRID | .REFC | .INDEP_DATA{:,1} | .ALPHA |
%      .INDEP_DATA{i} | .WT | .C | .G(:,1) |

global ErrCode;
global AT_NODES;

global BDF_Entity_Read_Settings;

fprintf (1, 'Проверка MPC...                         ');

% Установка настроек проверок
switch BDF_Entity_Read_Settings.Read_NODES
    case 'ON'
        Node_Related_Checks = 1;
    case 'OFF'
        Node_Related_Checks = 0;
    otherwise
        fprintf (1, '\nОшибка: непредвиденное значение параметра чтения BDF_Entity_Read_Settings.Read_NODES [%s] !\n', BDF_Entity_Read_Settings.Read_NODES);
        ErrCode = -1;
        return;
end

if (~isempty(AT_NODES))
    Max_Node_Number = size(AT_NODES,1);
else
    Max_Node_Number = 0;
end

for i=1:size(MPC,1)
    
    switch MPC{i}.card
        
        case 'RBAR'

            % Проверка на допустимость полей карточки
            if (~isempty(MPC{i}.ALPHA))
                fprintf (1, '\nОбнаружена запись ALPHA в MPC типа %s с номером %i !\n', MPC{i}.card, MPC{i}.ID);
                fprintf (1, 'MPC c полем ALPHA не поддерживаются в текущей версии программы.\n');
                fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;
            end
            
            if (~isempty(MPC{i}.CNA))
                fprintf (1, '\nОбнаружена запись CNA в MPC типа %s с номером %i !\n', MPC{i}.card, MPC{i}.ID);
                fprintf (1, 'RBAR с полем CNA не поддерживаются в текущей версии программы.\n');
                fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;
            end
            
            if (~isempty(MPC{i}.CMB))
                fprintf (1, '\nОбнаружена запись CMB в MPC типа %s с номером %i !\n', MPC{i}.card, MPC{i}.ID);
                fprintf (1, 'RBAR с полем CMB не поддерживаются в текущей версии программы.\n');
                fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;
            end
            
            if (isempty(MPC{i}.CNB))
                fprintf (1, '\nОбнаружена пустая запись CNB в MPC типа %s с номером %i !\n', MPC{i}.card, MPC{i}.ID);
                fprintf (1, 'RBAR с пустым полем CNB не поддерживаются в текущей версии программы.\n');
                fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;
            end
            
            if (isempty(MPC{i}.CMA))
                fprintf (1, '\nОбнаружена пустая запись CMA в MPC типа %s с номером %i !\n', MPC{i}.card, MPC{i}.ID);
                fprintf (1, 'RBAR с пустым полем CMA не поддерживаются в текущей версии программы.\n');
                fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;
            end
            
            if (MPC{i}.CNB == 0)
                fprintf (1, '\nОбнаружена нулевая запись CNB в MPC типа %s с номером %i !\n', MPC{i}.card, MPC{i}.ID);
                fprintf (1, 'RBAR с нулевым полем CNB не поддерживаются в текущей версии программы.\n');
                fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;
            end
            
            if (MPC{i}.CMA == 0)
                fprintf (1, '\nОбнаружена нулевая запись CMA в MPC типа %s с номером %i !\n', MPC{i}.card, MPC{i}.ID);
                fprintf (1, 'RBAR с нулевым полем CMA не поддерживаются в текущей версии программы.\n');
                fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;
            end
            
            if (MPC{i}.CNB ~= 123456)
                fprintf (1, '\nОбнаружена запись CNB, отличная от 123456, в MPC типа %s с номером %i !\n', MPC{i}.card, MPC{i}.ID);
                fprintf (1, 'Независимый узел RBAR со степенями свободы, отличными от 123456, не поддерживаются в текущей версии программы.\n');
                fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;
            end
            
            % Проверка на существование узлов
            if (Node_Related_Checks == 1)
                if (MPC{i}.GA > Max_Node_Number)
                    fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.GA);
                    ErrCode = -1;
                    return;
                end
                if (AT_NODES(MPC{i}.GA) == 0)
                    fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.GA);
                    ErrCode = -1;
                    return;
                end

                if (MPC{i}.GB > Max_Node_Number)
                    fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.GB);
                    ErrCode = -1;
                    return;
                end
                if (AT_NODES(MPC{i}.GB) == 0)
                    fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.GB);
                    ErrCode = -1;
                    return;
                end
            end
            
        case 'RBE2'

            % Проверка на допустимость полей карточки
            if (~isempty(MPC{i}.ALPHA))
                fprintf (1, '\nОбнаружена запись ALPHA в MPC типа %s с номером %i !\n', MPC{i}.card, MPC{i}.ID);
                fprintf (1, 'MPC c параметром ALPHA не поддерживаются в текущей версии программы.\n');
                fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;
            end
            
            % Проверка на существование узлов
            if (Node_Related_Checks == 1)
                
                if (MPC{i}.GN > Max_Node_Number)
                    fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.GN);
                    ErrCode = -1;
                    return;
                end
                if (AT_NODES(MPC{i}.GN) == 0)
                    fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.GN);
                    ErrCode = -1;
                    return;
                end

                for j=1:size(MPC{i}.GM,1)

                    if (MPC{i}.GM(j) > Max_Node_Number)
                        fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.GM(j));
                        ErrCode = -1;
                        return;
                    end
                    if (AT_NODES(MPC{i}.GM(j)) == 0)
                        fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.GM(j));
                        ErrCode = -1;
                        return;
                    end

                end
                
            end
            
        case 'RBE3'
            
            % Проверка на допустимость полей карточки
            if (~isempty(MPC{i}.ALPHA))
                fprintf (1, '\nОбнаружена запись ALPHA в MPC типа %s с номером %i !\n', MPC{i}.card, MPC{i}.ID);
                fprintf (1, 'MPC c параметром ALPHA не поддерживаются в текущей версии программы.\n');
                fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;
            end
            
            % Проверка на существование узлов
            
            if (Node_Related_Checks == 1)
            
                if (MPC{i}.REFGRID > Max_Node_Number)
                    fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.REFGRID);
                    ErrCode = -1;
                    return;
                end
                if (AT_NODES(MPC{i}.REFGRID) == 0)
                    fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.REFGRID);
                    ErrCode = -1;
                    return;
                end

                for j=1:size(MPC{i}.INDEP_DATA)

                    for k=1:size(MPC{i}.INDEP_DATA{j}.G, 1)

                        if (MPC{i}.INDEP_DATA{j}.G(k) > Max_Node_Number)
                            fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.INDEP_DATA{j}.G(k));
                            ErrCode = -1;
                            return;
                        end
                        if (AT_NODES(MPC{i}.INDEP_DATA{j}.G(k)) == 0)
                            fprintf (1, '\nMPC %i типа %s ссылается на несуществующий узел %i !\n', MPC{i}.ID, MPC{i}.card, MPC{i}.INDEP_DATA{j}.G(k));
                            ErrCode = -1;
                            return;
                        end

                    end

                end
            
            end
            
        otherwise
            
            fprintf (1, '\nНеизвестная карточка MPC с номером %i [%s] !\n', MPC{i}.ID, MPC{i}.card);
            ErrCode = -1;
            return;
        
    end
    
end

fprintf (1, 'OK!\n');
